import openpyxl #Libreria necesaria para manejo de excel
import os #Libreria necesaria para manejar archivos
import importlib
import errno

#constantes
database = "configuracion.xlsx"
servidor = "misitio"

#Inicializacion de las variables BEGIN
categoria = ""
title = ""
meta_description = ""
h1 = ""
parrafo_del_h1 = ""
html = ""
htmlMenu = ""
htmlProducto = ""
#Inicializacion de las variables END

#Creo directorio para las imagenes BEGIN
try:
    os.mkdir(servidor + "\\Images")
except OSError as e:
    if e.errno != errno.EEXIST:
        raise
#Creo directorio para las imagenes END

xls = openpyxl.load_workbook(database)
configuracion = xls["configuracion"] 
inicio = xls["inicio"] 
categorias = xls["categorias"] 
productos = xls["productos"] 
max_row=categorias.max_row
max_column=categorias.max_column
max_rowProduct=productos.max_row
max_columnProduct=productos.max_column

nombreSitio = configuracion.cell(row=2,column=1).value
dominio = configuracion.cell(row=2,column=2).value
tagAfiliado = configuracion.cell(row=2,column=3).value
mailContacto = configuracion.cell(row=2,column=4).value

paginaInicioTitle = inicio.cell(row=2,column=1).value
paginaInicioMetaDescription = inicio.cell(row=2,column=2).value
paginaInicioH1 = inicio.cell(row=2,column=3).value
paginaInicioParrafo = inicio.cell(row=2,column=4).value

#Abro archivo template Begin
fileTemplate = open("template.html",encoding="utf-8",mode="r")
while(True):
    linea = fileTemplate.readline()
    html = html + linea
    if not linea:
       break
fileTemplate.close()
#Abro archivo template End

## Armo el Menu (Transversal en todas las paginas) BEGIN
for f in range(1,max_row+1):
    cell_obj=categorias.cell(row=f,column=1) 
    url = cell_obj.value
    url = url.replace(" ","_") + ".php"  
    if cell_obj.value == "FIN":
        f = max_row
        break

    if categorias.cell(row=1,column=1).value  == "Categoria" and f > 1: 
        htmlMenu = htmlMenu + "<li class='nav-item'><a class='nav-link' href='"+ url +"'>" + cell_obj.value + "</a></li>"
## Armo el Menu (Transversal en todas las paginas) END

## Creo las paginas por cada categoria BEGIN
for f in range(1,max_row):
    htmlPage = html.replace("{{navvar}}",htmlMenu)

    for c in range(1,max_column+1): 
        cell_obj=categorias.cell(row=f,column=c)         

        if(f > 1):
            if categorias.cell(row=1,column=c).value == "Categoria":
                categoria = cell_obj.value
                for fp in range(2,max_rowProduct):
                    categoriaDelProducto = productos.cell(row=fp,column=1).value                     
                    if(categoriaDelProducto is not None and categoriaDelProducto == categoria):
                        htmlProducto = htmlProducto + "<div class='col-md-3'><div class='card mb-4 box-shadow'><div class='card-header priceHeader'><h2 class='my-0 font-weight-normal'>" + productos.cell(row=fp,column=2).value +"</h2></div>"
                        htmlProducto = htmlProducto + "<a href='https://www.amazon.es/gp/product/" + productos.cell(row=fp,column=5).value +"/ref=as_li_tl?ie=UTF8&creativeASIN="+ productos.cell(row=fp,column=5).value +"&tag=" + tagAfiliado + "' style='color: #333;text-decoration: none;'>"
                        htmlProducto = htmlProducto + "<div class='card-body'><img src='"+ productos.cell(row=fp,column=4).value + "' style='width: 100%;'><p>"+ productos.cell(row=fp,column=3).value  +"</p>"
                        htmlProducto = htmlProducto + "<button type='button' class='btn btn-lg btn-block btn-outline-primary' style='background-color: #febd69;color: #000;border: 0px;'>Ver en amazon</button></div></div></div>"                                                                                 
                        htmlProducto = htmlProducto + "</a>"

            if categorias.cell(row=1,column=c).value  == "Title":
                title = cell_obj.value

            if categorias.cell(row=1,column=c).value  == "Description":
                meta_description = cell_obj.value

            if categorias.cell(row=1,column=c).value  == "H1":
                h1 = cell_obj.value     

            if categorias.cell(row=1,column=c).value  == "Parrafo del h1":
                parrafo_del_h1 = cell_obj.value                          

    if categoria == "FIN":
        f = max_row
        break                     

    if f > 1:
        htmlPage = htmlPage.replace("{{categoria}}",categoria)        
        htmlPage = htmlPage.replace("{{title}}",title)        
        htmlPage = htmlPage.replace("{{meta_description}}",meta_description)        
        htmlPage = htmlPage.replace("{{meta_h1}}",h1)        
        htmlPage = htmlPage.replace("{{parrafo_del_h1}}",parrafo_del_h1)                   
        htmlPage = htmlPage.replace("{{html_producto}}",htmlProducto)  
        htmlPage = htmlPage.replace("\n","").replace("\t","")   
        htmlProducto = "" 
        
        ## Creo el archivo de cada pagina BEGIN
        print("Creando pagina de categoria " + categorias.cell(row=f,column=1).value)
        fileArchivo = open(servidor + "\\" + categoria.replace(" ","_") + ".php",encoding="utf-8", mode="w+")
        fileArchivo.write(htmlPage)
        fileArchivo.close()          
        ## Creo el archivo de cada pagina END

## Creo las paginas por cada categoria END

## Creo la pagina de inicio BEGIN
htmlPage = html.replace("{{navvar}}",htmlMenu)
cant = 0
for f in range(1,max_row+1):
    cell_obj=categorias.cell(row=f,column=1) 
    categoria = cell_obj.value
    if cell_obj.value == "FIN":
        f = max_row
        break 

    for fp in range(2,max_rowProduct):
        categoriaDelProducto = productos.cell(row=fp,column=1).value 

        if(categoriaDelProducto == categoria): 
            if(cant == 0):
                htmlProducto = htmlProducto + "<div class='col-md-12 text-center homeSeparador'> "+ categoriaDelProducto +" </div>"
            
            cant = cant + 1
            htmlProducto = htmlProducto + "<div class='col-md-3'><div class='card mb-4 box-shadow'><div class='card-header priceHeader'><h2 class='my-0 font-weight-normal'>" + productos.cell(row=fp,column=2).value +"</h2></div>"
            htmlProducto = htmlProducto + "<a href='https://www.amazon.es/gp/product/" + productos.cell(row=fp,column=5).value +"/ref=as_li_tl?ie=UTF8&creativeASIN="+ productos.cell(row=fp,column=5).value +"&tag="+ tagAfiliado + "' style='color: #333;text-decoration: none;'>"
            htmlProducto = htmlProducto + "<div class='card-body'><img src='"+ productos.cell(row=fp,column=4).value + "' style='width: 100%;'><p>"+ productos.cell(row=fp,column=3).value  +"</p>"
            htmlProducto = htmlProducto + "<button type='button' class='btn btn-lg btn-block btn-outline-primary' style='background-color: #febd69;color: #000;border: 0px;'>Ver en amazon</button></div></div></div>"                                                                                 
            htmlProducto = htmlProducto + "</a>"
            
            if(cant == 8):                
                cant=0
                break

print("Creando pagina de Inicio ")
htmlPage = htmlPage.replace("{{title}}",paginaInicioTitle)   
htmlPage = htmlPage.replace("{{meta_description}}",paginaInicioMetaDescription)        
htmlPage = htmlPage.replace("{{meta_h1}}",paginaInicioH1)        
htmlPage = htmlPage.replace("{{parrafo_del_h1}}",paginaInicioParrafo) 
htmlPage = htmlPage.replace("{{html_producto}}",htmlProducto)  
fileArchivo = open(servidor + "\\index.php",encoding="utf-8", mode="w+")
fileArchivo.write(htmlPage)
fileArchivo.close()    
## Creo la pagina de inicio END

## Creo la pagina de aviso legal BEGIN
htmlAvisoLegal = ""
fileTemplateAvisoLegal = open("template_avisolegal.html",encoding="utf-8",mode="r")
while(True):
    linea = fileTemplateAvisoLegal.readline()
    htmlAvisoLegal = htmlAvisoLegal + linea
    if not linea:
       break
fileTemplateAvisoLegal.close()

htmlAvisoLegal = htmlAvisoLegal.replace("{{title}}",nombreSitio + " - Aviso legal y politica de cookies")
htmlAvisoLegal = htmlAvisoLegal.replace("{{meta_description}}","Aqui vas a encontrar todo lo relacionado con la politica de cokies que manejamos en el sitio y los avisos legales correspondientes.")
htmlAvisoLegal = htmlAvisoLegal.replace("{{navvar}}",htmlMenu)
htmlAvisoLegal = htmlAvisoLegal.replace("{{configuracion_dominio}}",dominio)   
htmlAvisoLegal = htmlAvisoLegal.replace("{{configuracion_mailcontacto}}",mailContacto)

print("Creando pagina de Aviso Legal ")
fileArchivo = open(servidor + "\\avisolegal.php",encoding="utf-8", mode="w+")
fileArchivo.write(htmlAvisoLegal)
fileArchivo.close()    
## Creo la pagina de aviso legal END